> For a complete documentation index, fetch https://docs.voximplant.ai/llms.txt

# AddSubUser

POST https://api.voximplant.com/platform_api/AddSubUser

Creates a subuser.

Allowed roles: `Owner`.

**Example request:** Create a new subuser for account_id = 1.

Reference: https://docs.voximplant.ai/api-reference/management-api/reference/role-system/add-sub-user

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: management-api
  version: 1.0.0
paths:
  /AddSubUser:
    post:
      operationId: add-sub-user
      summary: AddSubUser
      description: |-
        Creates a subuser.

        Allowed roles: `Owner`.

        **Example request:** Create a new subuser for account_id = 1.
      tags:
        - subpackage_roleSystem
      parameters:
        - name: new_subuser_name
          in: query
          description: >-
            The new subuser login for management api authentication, should be
            unique within the Voximplant account. The login specified is always
            converted to lowercase
          required: true
          schema:
            type: string
        - name: new_subuser_password
          in: query
          description: >-
            The new subuser password. Must be at least 8 characters long and
            contain at least one uppercase and lowercase letter, one number, and
            one special character
          required: true
          schema:
            type: string
        - name: role_id
          in: query
          description: The role id list separated by semicolons (;)
          required: false
          schema:
            type: array
            items:
              type: integer
        - name: role_name
          in: query
          description: The role name list separated by semicolons (;)
          required: false
          schema:
            type: array
            items:
              type: string
        - name: description
          in: query
          description: Description of a new subuser
          required: false
          schema:
            type: string
        - name: Authorization
          in: header
          description: >-
            Voximplant Management API uses signed JWT tokens generated from your
            service-account private key. Pass the token in the `Authorization`
            header as a Bearer value:


            ```

            Authorization: Bearer $VOXIMPLANT_TOKEN

            ```


            See [Authorization](/api-reference/management-api/authorization) for
            ready-to-copy snippets in bash, Python, Node.js and Go that turn
            your `credentials.json` into a token.
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/role-system_AddSubUser_Response_200'
servers:
  - url: https://api.voximplant.com/platform_api
components:
  schemas:
    SubUserID:
      type: object
      properties:
        subuser_id:
          type: integer
          description: The subuser ID
      description: The [AddSubUser] function result.
      title: SubUserID
    role-system_AddSubUser_Response_200:
      type: object
      properties:
        result:
          $ref: '#/components/schemas/SubUserID'
      title: role-system_AddSubUser_Response_200
  securitySchemes:
    JwtAuth:
      type: http
      scheme: bearer
      description: >-
        Voximplant Management API uses signed JWT tokens generated from your
        service-account private key. Pass the token in the `Authorization`
        header as a Bearer value:


        ```

        Authorization: Bearer $VOXIMPLANT_TOKEN

        ```


        See [Authorization](/api-reference/management-api/authorization) for
        ready-to-copy snippets in bash, Python, Node.js and Go that turn your
        `credentials.json` into a token.

```

## SDK Code Examples

```python Example 1
import requests

url = "https://api.voximplant.com/platform_api/AddSubUser"

querystring = {"new_subuser_name":"new_subuser_name","new_subuser_password":"new_subuser_password"}

headers = {"Authorization": "Bearer <token>"}

response = requests.post(url, headers=headers, params=querystring)

print(response.json())
```

```javascript Example 1
const url = 'https://api.voximplant.com/platform_api/AddSubUser?new_subuser_name=new_subuser_name&new_subuser_password=new_subuser_password';
const options = {method: 'POST', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Example 1
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.voximplant.com/platform_api/AddSubUser?new_subuser_name=new_subuser_name&new_subuser_password=new_subuser_password"

	req, _ := http.NewRequest("POST", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Example 1
require 'uri'
require 'net/http'

url = URI("https://api.voximplant.com/platform_api/AddSubUser?new_subuser_name=new_subuser_name&new_subuser_password=new_subuser_password")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java Example 1
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.voximplant.com/platform_api/AddSubUser?new_subuser_name=new_subuser_name&new_subuser_password=new_subuser_password")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php Example 1
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.voximplant.com/platform_api/AddSubUser?new_subuser_name=new_subuser_name&new_subuser_password=new_subuser_password', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp Example 1
using RestSharp;

var client = new RestClient("https://api.voximplant.com/platform_api/AddSubUser?new_subuser_name=new_subuser_name&new_subuser_password=new_subuser_password");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift Example 1
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.voximplant.com/platform_api/AddSubUser?new_subuser_name=new_subuser_name&new_subuser_password=new_subuser_password")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```